unit Unit1;
//******************************************************************
//* Author          : Peter Carl Barnard                           *
//* Date written    : 2005/08/22                                   *
//* Delphi version  : 7 (Pro)                                      *
//*                                                                *
//* Description:-                                                  *
//*                                                                *
//* I am a converted "newbie" from Microsoft Visual Basic(R)       *
//* and have found too many "pro's" in using Delphi as opposed to  *
//* the alternative that our Microsoft friends have provided to    *
//* ignore.                                                        *
//*                                                                *
//* An EXREMELY knowledgeable fellow by the name of ZARKO runs a   *
//* very well kept website (delphi.about.com), and this is     *
//* where I basically "cut my teeth" on Delphi programming. The    *
//* site is a mine of information, and my advice to any "newbie"   *
//* who wants to start out in Delphi programming, is to really     *
//* explore this site - THANK YOU ZARKO!!!!                        *
//*                                                                *
//* OK - enough said,                                              *
//*                                                                *
//* I was tired of the confined space that I work in at home, and  *
//* to make matters worse...every CD/DVD type drive has it's OPEN/ *
//* CLOSE button UNDER the disk slider!!! Fine when you want to    *
//* OPEN the thing but (in my case) a problem when you need to bend*
//* around obstacles with a blind finger to try and close it again *
//*  - so would'nt it be nice to just use a "hotkey" to  get the   *
//* thing to open/close?                                           *
//*                                                                *
//* This program demonstrates a few very handy principles:-        *
//*                                                                *
//* 1) Opening/Closing your CD Drive programatically.              *
//* 2) Minimizing the program to the system tray.                  *
//* 3) Animating the tray icon.                                    *
//* 4) Creating a "hotkey" (to activate the CD Drive).             *
//* 5) How to display a "child" form (in this case Unit2) from a   *
//*    "parent" form (in this case Unit1).                         *
//*                                                                *
//* I have tried to put in as many comments as possible, but       *
//* if something is unclear, please visit Zarko's website...all    *
//* basics that are used in this program are very well documented  *
//* there...after all...that's where I learnt to start programming *
//* with Delphi....above all HAVE FUN AND EXPLORE                  *
//*                                                                *
//* Regards,                                                       *
//*                                                                *
//*     Peter                                                      *
//******************************************************************

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MMSystem, Menus, ShellAPI, ImgList, ExtCtrls, Unit2;

const
  //**************************************************
  //* Set up a handle to the callback procedure used *
  //* whenever a mouse event occurs over the program *
  //* icon in the system tray. See the procedure     *
  //* defined in the public declarations.            *
  //**************************************************
  WM_ICONTRAY = WM_USER + 1;


type
  TfrmCDControl = class(TForm)
    Pop1: TPopupMenu;
    PopOC: TMenuItem;
    Slash1: TMenuItem;
    PopEx: TMenuItem;
    Timer1: TTimer;
    IL: TImageList;
    PopAbout: TMenuItem;
    Slash2: TMenuItem;
    procedure PopExClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure PopOCClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure PopAboutClick(Sender: TObject);
  private
    //****************************************
    //* Set up system tray icon notification *
    //****************************************
    TrayIconData: TNotifyIconData;
    { Private declarations }
  public
    //******************************************************
    //* Set up a message handler for mouse events for when *
    //* the mouse is situated over the program icon in the *
    //* system tray                                        *
    //******************************************************
    procedure TrayMessage(var Msg: TMessage); message WM_ICONTRAY;
    //**************************************************
  //* QUESTION: What is a "Callback Procedure"?...   *
  //* Well it works like this:-                      *
  //*                                                *
  //* Imagine I were to call ZARKO and receive a     *
  //* voicemail and I left a message saying:-        *
  //*                                                *
  //* "Hi ZARKO, please let me know what the state   *
  //* of DELPHI.ABOUT is looking like"               *
  //*                                                *
  //* Note that I have'nt given a name or a return   *
  //* number. I'm EXPECTING that ZARKO knows who is  *
  //* calling, that he knows my RETURN number...and  *
  //* that he can provide me with the information I  *
  //* asked for.                                     *
  //*                                                *
  //* WELL...thats a callback procedure, except here *
  //* (the program) is going to call the operating   *
  //* system (sorry ZARKO :-)) and on response the   *
  //* program needs to prepare a "receiving"         *
  //* procedure to receive the peices of information *
  //* requested....Think of ME as program and ZARKO  *
  //* as WINDOWS (in this case).                     *
  //**************************************************
  //*
    //******************************************************
    //* Set up a message handler for the WM_HOTKEY message *
    //******************************************************
    procedure WMHotKey(var Msg2: TWMHotKey); message WM_HOTKEY;
    { Public declarations }
  end;

var
  //*******************************
  //* The definition of this form *
  //*******************************
  frmCDControl: TfrmCDControl;
  //*********************************************************
  //* An indicator to define the LAST state of the CD drive *
  //* The logic is simple: If the last state of the CD drive*
  //* was OUT ("O") then close it, if the last state of the *
  //* CD drive was IN ("I") then open it...thus this        *
  //* variable will always be set to "I" or "O"             *
  //* (It just keeps track of things)...                    *
  //*********************************************************
  CDSTATE: String;
  //***********************************************************
  //* This integer counter will be used to keep track of the  *
  //* icons used in the interval event of the timer used in   *
  //* in this form and produce the animated rotating CD effect*
  //* of the tray icon...the tray icon actually consists of   *
  //* four icons (indexed as 0 - 3 in ImageList IL)           *
  //***********************************************************
  TCnt: Integer;
  //**************************************************************
  //* This variable is of type TForm and will be used to create, *
  //* show and destroy "TfrmAbout" contained in Unit2            *
  //**************************************************************
  Fabout: TForm;

implementation
//***********************************************************************
//* As Mr. AH van Rooyen would say: "Never fiddle with the Green Stuff" *
//***********************************************************************
{$R *.dfm}

procedure TfrmCDControl.PopExClick(Sender: TObject);
begin
//*************************************************
//* This procedure will be executed when the user *
//* clicks on "Exit" of the tray icon popup menu  *
//* "Pop1"                                        *
//*************************************************
Close;
end;

procedure TfrmCDControl.FormCreate(Sender: TObject);
begin
//**********************************************
//* Initialize the TrayIconData data structure *
//**********************************************
With TrayIconData do
  begin
    cbSize := SizeOf(TrayIconData);
    Wnd := Handle;
    uID := 0;
    uFlags := NIF_MESSAGE + NIF_ICON + NIF_TIP;
    uCallBackMessage := WM_ICONTRAY;
    hIcon := Application.Icon.Handle;
    StrPCopy(szTip, Application.Title);
  end;
//*************************************************
//* Call the Shell_NotifyIcon API with NIM_ADD to *
//* add the program icon to the system tray       *
//*************************************************
Shell_NotifyIcon(NIM_ADD, @TrayIconData);
//*************************************
//* All done setting up the tray icon *
//* Now assign the hotkey for Win+C   *
//*************************************
if not RegisterHotKey(Handle, 1, MOD_WIN, ord('C')) then
  begin
    ShowMessage('Unable to assign WIN+C as a hotkey!!!');
    Close;
  end;
//**************************************************************
//* Assume that the CD drive is closed when this app starts??? *
//**************************************************************
CDSTATE := 'I';
//***************************************************************
//* Set the timer counter which acts as index to ImageList (IL) *
//* to zero, this counter facilitates the "animated tray icon"  *
//* effect 8-)                                                  *
//***************************************************************
TCnt := 0;
//***************************************************************
//* Now finally, when this application is run, remember that the*
//* main form is NOT SHOWN since we are creating a program that *
//* will reside in the system tray!!! How is this acheived...   *
//* Well look inside the code of Unit "CDControl", you'll see a *
//* line of code that goes: "Application.ShowMainForm := False;"*
//*                                                             *
//* This "hides" the application on startup (because we are     *
//* putting into the system tray)..BUT...it would be a good idea*
//* to let the user know that the program is present and running*
//* SO....                                                      *
//***************************************************************
MessageDlg('CD Control is running' + #13#10 + 'Check System Tray!!!', mtInformation, [mbOK], 0);
//****************************************************************
//* The phrase "#13#10" in the line above simply embeds Hex 0D0A *
//* Carriage Return, Line Feed, to split the two message parts   *
//****************************************************************
end;

procedure TfrmCDControl.TrayMessage(var Msg: TMessage);
//*****************************************************************
//* We're going to need to trap the exact X,Y co-ordinates of the *
//* mouse pointer when a left or right mouse button is clicked    *
//* over the icon we have established in the system tray...       *
//* so let's create a TPoint variable, this variable will have two*
//* very useful properties viz: X, Y which will "feed" us what we *
//* need to know...                                               *
//*****************************************************************
var PT: TPoint;
begin
//**************************************
//* Get the aforesaid X,Y co-ordinates *
//**************************************
GetCursorPos(PT); // In Pixels
//*************************************************
//* If the RIGHT mouse button has been clicked... *
//* pop up menu Pop1 using the X,Y co-ordinates   *
//* that were harvested from the above instruction*
//*************************************************
if Msg.LParam = WM_RBUTTONDOWN then
  Pop1.Popup(PT.X, PT.Y);
end;

//**************************************************
//* You might wonder why the same code is used for *
//* the "FormClose", the "FormCloseQuery" and      *
//* the "FormDestroy" events in the following event*
//* handlers:-                                     *
//*                                                *
//* Well, sometimes a user will close a program    *
//* "elegantly"...that is, they will click on the  *
//* the "Close" border icon or a provided "Exit"   *
//* button.                                        *
//*                                                *
//* BUT WHAT IF...the program is shutdown from     *
//* TASKMANAGER or otherwise rudely interrupted??? *
//*                                                *
//* Try as far as possible to kill all instances   *
//* of extraneous controls so that when the program*
//* starts up again, you don't run into any        *
//* previously running threads...                  *
//**************************************************

procedure TfrmCDControl.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
//*************************
//* Unregister the hotkey *
//*************************
UnRegisterHotKey(Handle,1);
//************************
//* Remove the tray icon *
//************************
Shell_NotifyIcon(NIM_DELETE, @TrayIconData);
end;

procedure TfrmCDControl.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
//*************************
//* Unregister the hotkey *
//*************************
UnRegisterHotKey(Handle,1);
//************************
//* Remove the tray icon *
//************************
Shell_NotifyIcon(NIM_DELETE, @TrayIconData);
end;

procedure TfrmCDControl.FormDestroy(Sender: TObject);
begin
//*************************
//* Unregister the hotkey *
//*************************
UnRegisterHotKey(Handle,1);
//************************
//* Remove the tray icon *
//************************
Shell_NotifyIcon(NIM_DELETE, @TrayIconData);
end;

procedure TfrmCDControl.WMHotKey(var Msg2: TWMHotKey);
begin
//*****************************************************
//* This procedure does the actual activation of the  *
//* CD drive. It involves "faffing" about with the    *
//* operating system, but generally you could accept  *
//* this peice of code as a reliable "means to an end"*
//*****************************************************
if Msg2.HotKey = 1 then
  begin
    if CDSTATE = 'I' then
        mciSendString('Set CDAudio Door Open wait', nil, 0, Handle);
    if CDSTATE = 'O' then
        mciSendString('Set CDAudio Door Closed wait', nil, 0, Handle);
    if CDSTATE = 'I' then
        CDSTATE := 'O'
    else
        CDSTATE := 'I';
  end;
end;


procedure TfrmCDControl.PopOCClick(Sender: TObject);
begin
//***************************************************
//* CDSTATE is simply a globally defined variable:- *
//* it's basically just a flag to let the program   *
//* know what THE LAST STATE of the CD drive was... *
//* IN or OUT - hence "I" or "O"...Hmmmm could just *
//* as well have used a BOOLEAN variable here....   *
//***************************************************
if CDSTATE = 'I' then
    mciSendString('Set CDAudio Door Open wait', nil, 0, Handle);
if CDSTATE = 'O' then
    mciSendString('Set CDAudio Door Closed wait', nil, 0, Handle);
//******************************************************************
//* Be careful to isolate the following test AFTER opening/closing *
//* the CD drive, if you try to include the "CDSTATE :=" phrases   *
//* in their partner "if" staements above, you will end up with a  *
//* CD drive that simply bounces open and closed...heh...heh...heh *
//******************************************************************
if CDSTATE = 'I' then
    CDSTATE := 'O'
else
    CDSTATE := 'I';
end;

procedure TfrmCDControl.Timer1Timer(Sender: TObject);
var Icon: TIcon;
begin
//****************************************************
//* Make sure that the timer counter does'nt extend  *
//* the range 0 - 3 (or a count of 4)                *
//****************************************************
If TCnt > 3 then
  TCnt := 0;
//****************************************************
//* Grab the icon from ImageList IL and use it at an *
//* interval of 200 Ms to modify the tray icon...note*
//* that there are four icons in IL (0 - 3) and they *
//* are going to be rotated (excuse the pun) by using*
//* TCnt (Timer Counter) as an index...              *
//****************************************************
Icon := TIcon.Create;
IL.GetIcon(TCnt, Icon);
TrayIconData.hIcon := Icon.Handle;
//****************************************************************
//* Here we use the NIM_MODIFY parameter to Shell_NotifyIcon API *
//* to change the system tray icon...                            *
//****************************************************************
Shell_NotifyIcon(NIM_MODIFY, @TrayIconData);
//**************************************
//* Increment TCnt by 1 every cycle... *
//**************************************
Inc(TCnt);
//*******************************************************
//* Finally...make sure to free up the instance of Icon *
//*******************************************************
Icon.Free;
end;

procedure TfrmCDControl.PopAboutClick(Sender: TObject);
begin
//************************************************************
//* This is (probably) the best way to show a "child" form   *
//* from a "parent" form - Zarko in his wisdom may have      *
//* devised a better way, but so far I have found this to    *
//* be infallible. It works like this:-                      *
//*                                                          *
//*   1) CREATE the child form internally from the parent,   *
//*      have a look up top in the VAR globally defined      *
//*      declaratives of this unit, you will see a statement *
//*      that looks like this:                               *
//*           Fabout: TForm;                                 *
//*      This merely creates a variable "Fabout" of type     *
//*      "TForm".                                            *
//*                                                          *
//*      In the same VAR declaratives inside Unit2 you will  *
//*      find a statement that looks like this:              *
//*           frmAbout: TfrmAbout;                           *
//*                                                          *
//*      Now to create this form we need to instance the     *
//*      "TForm" variable of parent form (Unit1) to          *
//*      "TfrmAbout" object of the child form (Unit2), we do *
//*      this with the following instruction:                *
//************************************************************
FAbout := TfrmAbout.Create(Self);
//************************************************************
//* The parameter "Self" indicates that "ME" as Unit1 are    *
//* creating "YOU" as Unit2 (or form TfrmAbout)...           *
//* Next we actually have to show this form...remember...at  *
//* this stage, all we have done is to create an instance of *
//* "TfrmAbout". I want to point out that there are various  *
//* kinds of child forms...most notably "MODAL" and          *
//* "NONMODAL"...but it is safe to say that (if handled      *
//* correctly) you will normally be dealing with MODAL forms *
//* SO:                                                      *
//*                                                          *
//*   2) Show variable "FAbout" of type "TForm" assigned to  *
//*      object "TfrmAbout" in "Unit2" in it's modal kind    *
//*      thus:                                               *
//************************************************************
FAbout.ShowModal;
//************************************************************
//* At this point program control is handed over to "child"  *
//* form "frmFabout" contained within Unit2 and described by *
//* type "TfrmAbout". What now happens is that the "ABOUT"   *
//* form pops up and displays what an idiot I am for not     *
//* using beautiful fonts etc. But the job is done...the     *
//* child form has been displayed.                           *
//*                                                          *
//* The last consideration is what happens after "child"     *
//* form is closed (ended) and control returns to the calling*
//* "parent" form...a little controvesy here...remember that *
//* displaying forms all over the place takes up CPU memory  *
//* that ideally should be freed up if the form is no longer *
//* in use. Both Microsoft Visual Basic and Borland Delphi   *
//* claim that when a "CLOSE" type operation is executed,   *
//* the memory is freed up, but I have found this not to be  *
//* the case...I have found traces of malingering instances  *
//* (not even reported by Windows Task Manager) to be        *
//* residing in memory. The next statement will only be      *
//* executed when control returns to the calling "parent"    *
//* form...and so to completely eradicate it from memory:    *
//*   3) Destroy it's instance like this:                    *
//************************************************************
FAbout.Destroy;
//************************************************************
//* That's it!!! We have created, shown and destroyed a child*
//* form                                                     *
//************************************************************
end;

end.
